#include "stm32f0xx.h"
#include "DMB/rejestry.h"
#include "DMB/debug.h"
#include "RCC/RCC.h"
#include "delay_systick/delay_systick.h"

#include "lcd_ILI9341.h"
#include "PRZYCISKI/przyciski.h"
#include "sudoku.h"


void _delay(unsigned int x)
{
	while (x--);
}


int main(void)
{
	// inicjalizacja zagara - pllx7 z HSE
	RCC_init();
	delay_init();

	// wlaczenie zegara dla portu A i B
	RCC->AHBENR |= RCC_AHBENR_GPIOAEN;
	RCC->AHBENR |= RCC_AHBENR_GPIOBEN;

	// inicjalizacja LCD
	_delay_ms( 100 );
	lcd_init();
	_delay_ms( 100 );

	LCD_LED_OUT;
	LCD_LED_ON;

	// powitanie oraz uruchomienie nowej gry
	powitanie();
	restart_planszy();
	uruchom_wybor_planszy();


	// przypisanie funkcji do przyciskow
	button_ustaw(0,5,200,50,sudoku_button_up,	NULL );
	button_ustaw(1,5,200,50,sudoku_button_left,	NULL );
	button_ustaw(2,5,200,50,sudoku_button_ok,	NULL );
	button_ustaw(3,5,200,50,sudoku_button_right,NULL );
	button_ustaw(4,5,200,50,sudoku_button_down,	NULL );

	// inicjalizacja obslugi przyciskow
	init_buttons();

	while(1)
	{
		// sprawdzenie eventu od przyciskow
		buttons_check_events();

		// oczekiwanie na przerwanie
		__WFI();
	}
}

